package jp.go.ipa.sample.component.service;

import android.app.ActivityManager;
import android.util.Log;
import android.widget.Button;
import jp.go.ipa.sample.component.service.R;
import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.SystemClock;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import java.util.List;

/**
 * ClientからIntentを受信してサービスを起動するアプリ
 *
 * メイン画面Activityクラス
 */
public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
	}

    @Override
    protected void onResume() {
        super.onResume();
        // バックアップ処理起動状態更新
        updateBackupStatus();
    }

    /**
	 * バックアップ処理起動状態更新
	 */
	private void updateBackupStatus() {
		TextView textRun = (TextView) findViewById(R.id.textRun);
        Button stopButton = (Button) findViewById(R.id.button_stop);

        if (isRunning()) {
			// 稼働中の場合
			textRun.setText("稼働中");
			textRun.setTextColor(Color.RED);
		} else {
			// 停止中の場合
			textRun.setText("停止中");
			textRun.setTextColor(Color.BLACK);
		}
        stopButton.setEnabled(isRunning());
	}

	/**
	 * 停止ボタンタップ
	 */
	public void onClickStop(View v) {
        if(isRunning()){
            BackupService backupService
                    = new BackupService();
            backupService.stopResident(this);
            this.stopService(new Intent(this,BackupService.class));

            Toast.makeText(this, "バックアップ処理を停止しました", Toast.LENGTH_SHORT).show();
            updateBackupStatus();
        }
	}


	/**
	 * 稼働状態
	 */
	private boolean isRunning() {
		if (isServiceRunning(this,BackupService.class)) {
            // 稼働中
            return true;
		} else {
            // 停止中
            return false;
		}
	}

    public boolean isServiceRunning(Context c, Class<?> cls) {
        ActivityManager am = (ActivityManager) c.getSystemService(Context.ACTIVITY_SERVICE);
        List<ActivityManager.RunningServiceInfo> runningService = am.getRunningServices(Integer.MAX_VALUE);
        for (ActivityManager.RunningServiceInfo i : runningService) {
            if (cls.getName().equals(i.service.getClassName())) {
                return true;
            }
        }
        return false;
    }
}
