package jp.go.ipa.sample.component.contentprovider;


import android.content.ContentProvider;
import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteQueryBuilder;
import android.net.Uri;

/**
 * 画像データをやりとりするContentProvider
 */
public class PictureProvider extends ContentProvider {

    MyDbHelper myDbHelper;

    @Override
    public boolean onCreate() {
        myDbHelper = new MyDbHelper(getContext());
        return true;
    }

    @Override
    public Cursor query(Uri uri, String[] strings, String s, String[] strings2, String s2) {
        SQLiteDatabase database = myDbHelper.getReadableDatabase();
        SQLiteQueryBuilder queryBuilder = new SQLiteQueryBuilder();
        queryBuilder.setTables("image");
        String columns[] = { "_id", "name", "data" };
        Cursor cursor = queryBuilder.query(database, columns, null, null, null, null, "name");
        return cursor;
    }

    @Override
    public String getType(Uri uri) {
        return null;
    }

    @Override
    public Uri insert(Uri uri, ContentValues contentValues) {
        SQLiteDatabase database = myDbHelper.getWritableDatabase();
        database.insert("image", null, contentValues);
        return null;
    }

    @Override
    public int delete(Uri uri, String s, String[] strings) {
        // テーブル内データを全消去
        SQLiteDatabase database = myDbHelper.getWritableDatabase();
        int deleteColumns = database.delete("image", null, null);
        return deleteColumns;
    }

    @Override
    public int update(Uri uri, ContentValues contentValues, String s, String[] strings) {
        return 0;
    }

}
