package jp.go.ipa.sample.fileaccess.data;

import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

import jp.go.ipa.sample.fileaccess.data.R;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

/**
 * 登録画面Activityクラス
 */
public class RegisterActivity extends Activity {

	/** ファイル名 */
	private final String STRAGE_FILE_NAME = "APPDATA";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_register);
	}

	/*
	 * 登録ボタンタップ
	 */
	public void onClickRegister(View v) {
		// 入力された各情報の取得
		String name = ((EditText) findViewById(R.id.edittextName)).getText().toString();
		String id = ((EditText) findViewById(R.id.edittextId)).getText().toString();
		String pass = ((EditText) findViewById(R.id.edittextPass)).getText().toString();
		String url = ((EditText) findViewById(R.id.edittextUrl)).getText().toString();
		String etc = ((EditText) findViewById(R.id.edittextEtc)).getText().toString();

		// 名称が未入力の場合はメッセージ表示
		if ("".equals(name)) {
			Toast.makeText(this, "名称は必須項目です", Toast.LENGTH_LONG).show();
			return;
		}

		OutputStream outputStream = null;
		PrintWriter printWriter = null;
		try {
			// ▼▼▼脆弱性のあるソースコード▼▼▼
			// ファイルを開く処理
			outputStream = openFileOutput(STRAGE_FILE_NAME, MODE_WORLD_READABLE | MODE_APPEND);
			// ▲▲▲脆弱性のあるソースコード▲▲▲

			printWriter = new PrintWriter(new OutputStreamWriter(outputStream, "UTF-8"));
			printWriter.append(name + "\r\n" + id + "\r\n" + pass + "\r\n" + url + "\r\n" + etc + "\r\n");
			Toast.makeText(this, "登録しました", Toast.LENGTH_LONG).show();
		} catch (IOException e) {
			// 書き込み失敗
			Toast.makeText(this, "内部ストレージに書き込めませんでした", Toast.LENGTH_LONG).show();
			e.printStackTrace();
		} finally {
			if (printWriter != null) {
				printWriter.close();
			}
		}
		finish();
	}
}
