package jp.go.ipa.sample.fileaccess.preference;

import jp.go.ipa.sample.fileaccess.preference.R;
import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.view.View;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

/**
 * メイン画面Activityクラス
 */
public class MainActivity extends Activity {

	/** PREFERENCE名 */
	private final String PREFERENCE_NAME = "PREFERENCE_NAME";
	/** PREFERENCEキー ユーザID */
	private final String PREFERENCE_KEY_ID = "PREFERENCE_KEY_ID";
	/** PREFERENCEキー パスワード */
	private final String PREFERENCE_KEY_PASS = "PREFERENCE_KEY_PASS";
	/** PREFERENCEキー 保存状態 */
	private final String PREFERENCE_KEY_CHECK = "PREFERENCE_KEY_CHECK";

	/** PREFERENCE */
	private SharedPreferences preferences = null;
	/** EditText ユーザID */
	private EditText edittextId = null;
	/** EditText パスワード */
	private EditText edittextPass = null;
	/** CheckBox 保存状態 */
	private CheckBox checkLogin = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		// 各Viewを設定する
		edittextId = (EditText) findViewById(R.id.edittextId);
		edittextPass = (EditText) findViewById(R.id.edittextPass);
		checkLogin = (CheckBox) findViewById(R.id.checkLogin);

		// PREFERENCE初期化
		initPreference();
	}

	/**
	 * PREFERENCE初期化
	 */
	private void initPreference() {

		// ▼▼▼脆弱性のあるソースコード▼▼▼
		// SharedPreferences型インスタンスを取得
		preferences = getSharedPreferences(PREFERENCE_NAME, MODE_WORLD_READABLE);
		// ▲▲▲脆弱性のあるソースコード▲▲▲

		boolean check = preferences.getBoolean(PREFERENCE_KEY_CHECK, false);
		if (check) {
			// 保存状態にチェックありの場合、設定情報をEditTextに設定する
			checkLogin.setChecked(check);
			edittextId.setText(preferences.getString(PREFERENCE_KEY_ID, ""));
			edittextPass.setText(preferences.getString(PREFERENCE_KEY_PASS, ""));
		} else {
			// 保存状態にチェックなしの場合、空文字をEditTextに設定する
			checkLogin.setChecked(check);
			edittextId.setText("");
			edittextPass.setText("");
		}
	}

	/*
	 * ログインボタンタップ
	 */
	public void onClickLogin(View v) {
		// 入力されたIDとパスワードの取得
		String id = edittextId.getText().toString();
		String pass = edittextPass.getText().toString();
		boolean check = checkLogin.isChecked();

		// 未入力項目がある場合はメッセージ表示
		if ("".equals(id) || "".equals(pass)) {
			Toast.makeText(this, "入力内容に不備があります", Toast.LENGTH_LONG).show();
			return;
		}

		Editor editor = preferences.edit();
		if (check) {
			// 保存状態にチェックありの場合、PREFERENCEに入力された値を設定する
			editor.putString(PREFERENCE_KEY_ID, id);
			editor.putString(PREFERENCE_KEY_PASS, pass);
			editor.putBoolean(PREFERENCE_KEY_CHECK, check);
		} else {
			// 保存状態にチェックなしの場合、保存状態以外のPREFERENCEを削除する
			editor.remove(PREFERENCE_KEY_ID);
			editor.remove(PREFERENCE_KEY_PASS);
			editor.putBoolean(PREFERENCE_KEY_CHECK, check);
		}
		editor.commit();

		// メニュー画面に遷移
		Intent intent = new Intent(this, MenuActivity.class);
		intent.putExtra("id", id);
		startActivity(intent);
	}
}
