package jp.go.ipa.sample.component.broadcast.sender;

import jp.go.ipa.sample.component.broadcast.sender.R;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

/**
 * メイン画面Activityクラス
 */
public class MainActivity extends Activity {

	@Override
	protected void onPause() {
		super.onPause();
		finish();
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		// 画像名リスト作成
		createPictureList();
	}

	/**
	 * 画像名リスト作成
	 */
	private void createPictureList() {

		// 画像名をListViewに設定する
		ListView listFriend = (ListView) findViewById(R.id.listFriend);
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_single_choice);
			adapter.add("picture1.png");
			adapter.add("picture2.png");
			adapter.add("picture3.png");
		listFriend.setAdapter(adapter);
		listFriend.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
	}

	/*
	 * 送信ボタンタップ
	 */
	public void onClickSend(View v) {
		// 画像の取得
		ListView listFriend = (ListView) findViewById(R.id.listFriend);
		int pos = listFriend.getCheckedItemPosition();

		// 画像が指定されていない場合は以降の処理は行わない
		if (pos < 0) {
			Toast toast = Toast.makeText(this, "画像を選択してください", Toast.LENGTH_SHORT);
			toast.setGravity(Gravity.AXIS_CLIP, 0, 0);
			toast.show();
			return;
		}
		String pictureName = (String) listFriend.getItemAtPosition(pos);

        // ▼▼▼脆弱性のあるソースコード▼▼▼
		// 暗黙的Intentを使用
		Intent intent = new Intent("sampleapp.message.receiver");

		intent.putExtra("pictureName", pictureName);
		sendBroadcast(intent);
		// ▲▲▲脆弱性のあるソースコード▲▲▲
	}
	
	/*
	 * 未実装機能のボタンが押された時
	 */
	public void onClickUnimplementButton(View v) {
		
		Toast toast = Toast.makeText(this, "現在使用できません", Toast.LENGTH_SHORT);
		toast.setGravity(Gravity.AXIS_CLIP, 0, 0);
		toast.show();
		
	}

}
