package jp.go.ipa.sample.javascriptInterface;

import android.content.Context;
import android.widget.Toast;
import android.app.Activity;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.telephony.TelephonyManager;
import android.webkit.WebView;

/**
 * Intentで受け取ったURLをWebViewに表示するクラス
 */
public class WebViewActivity extends Activity {

    WebView webView;
    Uri uri;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_sub);

        uri = getIntent().getData();

        webView = (WebView) findViewById(R.id.webView);
        // ▼▼▼脆弱性のあるソースコード▼▼▼
        // javascriptInterfaceを有効にする
        webView.getSettings().setJavaScriptEnabled(true);
        webView.addJavascriptInterface(this, "javascriptInterface");
        // ▲▲▲脆弱性のあるソースコード▲▲▲
    }

    //JavascriptInterface経由で電話番号を返す
    public String getLine1Number() {
        return ((TelephonyManager) getSystemService(TELEPHONY_SERVICE)).getLine1Number();
    }

    @Override
    protected void onResume() {
        super.onResume();
        LoadIntentUrl loadIntentUrl = new LoadIntentUrl(getApplication().getApplicationContext());
        loadIntentUrl.execute(uri.toString());
    }

    public void showToast() {
        Toast.makeText(getApplication().getApplicationContext(), "現在使用できません", Toast.LENGTH_LONG).show();
    }

    class LoadIntentUrl extends AsyncTask<String, Void, Void> {

        private Context mContext;

        LoadIntentUrl(Context context) {
            this.mContext = context;
        }

        @Override
        protected Void doInBackground(String... params) {
            webView.loadUrl(params[0]);
            return null;
        }

        @Override
        protected void onCancelled() {
            super.onCancelled();
            Toast.makeText(getApplication().getApplicationContext(),"SSLエラーが発生したため、通信をキャンセルしました",Toast.LENGTH_LONG).show();
        }

    }
}
