package jp.go.ipa.sample.outputlog;

import jp.go.ipa.sample.outputlog.R;
import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

/**
 * メイン画面Activityクラス
 */
public class MainActivity extends Activity {

	/** 銀行URL */
	final private String URL_ONLINEBANK = "http://www.onlinebank.example.co.jp/login.html";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
	}

	/*
	 * ログインボタンタップ
	 */
	public void onClickLogin(View v) {
		// 入力された契約番号とパスワードの取得
		String id = ((EditText) findViewById(R.id.edittextId)).getText().toString();
		String pass = ((EditText) findViewById(R.id.edittextPass)).getText().toString();

		// 未入力項目がある場合はメッセージ表示
		if ("".equals(id) || "".equals(pass)) {
			Toast.makeText(this, "入力内容に不備があります", Toast.LENGTH_LONG).show();
			return;
		}

		// 入力内容をログに出力する
		String log = "ID:" + id + " PASS:" + pass;

		// ▼▼▼脆弱性のあるソースコード▼▼▼
		// ログ出力
		Log.v(getPackageName(), log);
		// ▲▲▲脆弱性のあるソースコード▲▲▲

		Intent intent = new Intent(this, MenuActivity.class);
		
		// URLにトークン情報を設定
		String param = String.format("%s?token=%s", URL_ONLINEBANK, getToken(id ,pass));
		
		// ▼▼▼脆弱性のあるソースコード▼▼▼
		// 情報を明示的Intentに設定
		intent.setData(Uri.parse(param));
		// ▲▲▲脆弱性のあるソースコード▲▲▲

		startActivity(intent);
	}
	
	/*
	 * トークン取得
	 */
	private String getToken(String id, String pass){
		// サンプルアプリのため、トークンは固定値にしています
		return "123456";
	}
}
