package jp.go.ipa.sample.sslconnection;

import android.app.Activity;
import android.content.Context;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.webkit.WebView;

import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import java.security.KeyStore;

import jp.go.ipa.sample.sslconnection.R;

public class MainActivity extends Activity {

    WebView webView;
    Uri uri;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        webView = (WebView) findViewById(R.id.webView);

        Uri.Builder builder = new Uri.Builder();
        builder.scheme("https");//プロトコルにHTTPSを使用する
        builder.authority("192.168.0.191");//接続先サーバーのURL
        uri = builder.build();

    }

    @Override
    protected void onResume() {
        super.onResume();
        PrivateCertHttpsConnect privateCertHttpsConnect = new PrivateCertHttpsConnect(getApplication().getApplicationContext());
        privateCertHttpsConnect.execute(uri.toString());
    }

    class PrivateCertHttpsConnect extends AsyncTask<String, Void, Void> {

        private Context mContext;

        PrivateCertHttpsConnect(Context context) {
            mContext = context;
        }

        @Override
        protected Void doInBackground(String... params) {
            DefaultHttpClient client = new DefaultHttpClient();

            try {

                //Private証明書をassetsから読み込み、検証
                KeyStore ks = KeyStoreUtil.getEmptyKeyStore();
                KeyStoreUtil.loadX509Certificate(ks,
                        mContext.getResources().getAssets().open("server.crt"));

                // ▼▼▼脆弱性のあるコード▼▼▼
                // 1.独自でTrustManagerを実装したクラス（PrivateSSLSocketFactory）を実装
                // 2.HostnameVerifierにSSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIERをセット
                SSLSocketFactory sslSocketFactory = new PrivateSSLSocketFactory(ks);
                sslSocketFactory.setHostnameVerifier(SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);
                Scheme sch = new Scheme("https", sslSocketFactory, 443);
                // ▲▲▲脆弱性のあるコード▲▲▲

                client.getConnectionManager().getSchemeRegistry().register(sch);

                HttpGet request = new HttpGet(params[0]);

                HttpResponse response = client.execute(request);

                webView.loadData(EntityUtils.toString(response.getEntity()), "text/html", "UTF-8");
            // ▼▼▼脆弱性のあるコード▼▼▼
            } catch (Exception e) {

            }
            // ▲▲▲脆弱性のあるコード▲▲▲
            return null;
        }

    }

}
