package jp.go.ipa.sample.sslconnection;

import org.apache.http.conn.ssl.SSLSocketFactory;

import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;
import java.security.*;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

public class PrivateSSLSocketFactory extends SSLSocketFactory {

    SSLContext sslContext = SSLContext.getInstance("TLS");

    public PrivateSSLSocketFactory(KeyStore truststore)
            throws NoSuchAlgorithmException, KeyManagementException,
            KeyStoreException, UnrecoverableKeyException {

        super(truststore);

		// ▼▼▼脆弱性のあるソースコード▼▼▼
        // SSLExceptionを回避するため何も処理を行わない空のTrustManagerを作成
        // 自己署名証明書を受け付けるカスタムSSLContextの準備
        TrustManager tm = new X509TrustManager() {
            public void checkClientTrusted(X509Certificate[] chain,
                                           String authType) throws CertificateException {
                //どんな証明書でも受け入れる
            }

            public void checkServerTrusted(X509Certificate[] chain,
                                           String authType) throws CertificateException {
                //どんな証明書でも受け入れる
            }

            public X509Certificate[] getAcceptedIssuers() {
                return null;
            }
        };
		// ▲▲▲脆弱性のあるソースコード▲▲▲

        sslContext.init(null, new TrustManager[]{tm}, null);
    }

    @Override
    public Socket createSocket(Socket socket, String host, int port,
                               boolean autoClose) throws IOException, UnknownHostException {
        // カスタムSSLContext経由で生成したSSLソケットを返す。
        return sslContext.getSocketFactory().createSocket(socket, host, port, autoClose);
    }

    @Override
    public Socket createSocket() throws IOException {
        // カスタムSSLContext経由で生成したSSLソケットを返す。
        return sslContext.getSocketFactory().createSocket();
    }
}