/*----------------------------------------*/
/*  breadCrumb.js ( 2012/11/16 )
 /*  http://tshinobu.com/lab/breadCrumbJs/
 /*  readcrumb (topicpath) generator by javascript
 /*----------------------------------------*/

breadCrumbJsData = function () {
    /*----------------------------------------*/
    /*  ルートからContentsフォルダまでのパスを取得し、
     *	 パンくずリストから除外するパスに指定する処理
     /*----------------------------------------*/
    var URL = window.location.pathname;

    var $dir = URL.split("/");

    // 各シナリオのフォルダの１つ上の階層まで無視する
    var lastIndex = URL.lastIndexOf($dir[$dir.length - 3]);
    var ignoreTarget = URL.substring(1, lastIndex);
    this.ignorePath = ignoreTarget;

    //グループ選択時
    this.groupContentName = {
        "index.html": "概要"
    };

    //デフォルト
    this.defaultContentName = {
        "index.html": "概要",
        "2.html": "サンプルコード解説",
        "3.html": "脆弱性体験",
        "4.html": "サンプルアプリの脆弱性説明",
        "5.html": "脆弱性対策方法",
        "6.html": "脆弱性対策体験"
    };

    //デフォルト以外の学習シナリオ用（攻撃アプリが無い場合のページ構成、パンくずリストに表示する文言が異なるなど）
    this.contentName = {
        "SSL/1/index.html": "概要",
        "SSL/1/2.html": "サンプルコード解説",
        "SSL/1/3.html": "サンプルアプリの脆弱性説明",
        "SSL/1/4.html": "脆弱性対策方法",
        "SSL/1/5.html": "脆弱性対策体験",

        "Permission/1/index.html": "概要",
        "Permission/1/2.html": "サンプルコード解説",
        "Permission/1/3.html": "問題の体験",
        "Permission/1/4.html": "サンプルアプリの問題説明",
        "Permission/1/5.html": "問題への対策方法",
        "Permission/1/6.html": "問題への対策体験",

        "Start/1/index.html": "Androidアプリの基礎知識",
        "Start/1/2.html": "Androidとは",
        "Start/1/3.html": "Androidアプリの特徴",
        "Start/1/4.html": "Android OSの仕組み",

        "JavascriptInterface/1/index.html": "概要",
        "JavascriptInterface/1/2.html": "サンプルコード解説",
        "JavascriptInterface/1/3.html": "脆弱性体験",
        "JavascriptInterface/1/4.html": "サンプルアプリの脆弱性説明",
        "JavascriptInterface/1/5.html": "脆弱性対策方法",
        "JavascriptInterface/1/6.html": "脆弱性対策体験",
        "JavascriptInterface/1/7.html": "参考"
    };

};

var breadCrumbJsData = new breadCrumbJsData();

function breadCrumbJs() {

    /*----------------------------------------*/
    /*  以下条件分岐 / 表示処理部分
     /*----------------------------------------*/
    var URL = window.location.pathname.replace(breadCrumbJsData.ignorePath, '');

    var thisURL = new Array();

    //連想配列のサイズを保持する
    var arraysize = 0;

    if (!isGroupPage(URL)) {
        for (key in breadCrumbJsData.groupContentName) {
            thisURL[key] = breadCrumbJsData.groupContentName[key];
            arraysize++;
        }
    } else {
        if (!isExceptionPath(URL)) {
            for (key in breadCrumbJsData.defaultContentName) {
                thisURL[key] = breadCrumbJsData.defaultContentName[key];
                arraysize++;
            }
        } else {
            for (key in breadCrumbJsData.contentName) {
                if (key.substring(0, key.lastIndexOf("/")) == URL.substring(1, URL.lastIndexOf("/"))) {
                    thisURL[key.substring(key.lastIndexOf("/") + 1, key.length)] = breadCrumbJsData.contentName[key];
                    arraysize++;
                }
            }
        }
    }

    var drw = document.getElementById("navibar");

    var browserJudgement = browser();

    // chrome,firefoxとIEでファイルパスを取得した時のディレクトリの区切り文字が異なるので場合分け
    if (browserJudgement == "ie") {
        var fileName = document.URL.substring(document.URL.lastIndexOf("\\") + 1, document.URL.length);
    } else if (browserJudgement == "chrome" || "firefox" || "safari") {
        var fileName = document.URL.substring(document.URL.lastIndexOf("/") + 1, document.URL.length);
    }

    //パンくずリストを作った回数
    var putCount = 0;

    var html = '<table><tr><td>';

    for (var key in thisURL) {
        if (key == fileName) {
            html += '<strong >' + thisURL[key] + '</strong>';
        } else {
            html += ' <a href="./' + key + '">' + thisURL[key] + '</a>';
        }
        putCount++;
        //最後の要素の場合は>を追加しない
        if (putCount != arraysize) {
            html += ' &gt; ';
        }
    }
    html += '</td><td align="right" width="130">' + '<div class="navi-buttons"><a href="#" class="navigation-button" id="button_back">back</a>' + '&nbsp;&nbsp;&nbsp;' + '<a href="#"  class="navigation-button" id="button_next">next</a></div>' + '</td></tr></table>';

    drw.innerHTML += html;


}

/**
 * 他と構成が異なるシナリオかどうかのチェック
 * @param filePath
 * @return boolean
 */
function isExceptionPath(filePath) {

    //構成が異なるシナリオのファイルパスを記述
    var paths = ['/SSL/1', '/Permission/1', '/Start/1', '/Start/2', '/JavascriptInterface/1'];

    var contentPath = filePath.substring(0, filePath.lastIndexOf("/"));

    if (paths.indexOf(contentPath) == -1) {
        return false;
    } else {
        return true;
    }
}

/**
 * UserAgent によるブラウザ判定
 */
function browser() {
    var userAgent = window.navigator.userAgent.toLowerCase();

    if (userAgent.indexOf('opera') != -1) {
        return 'opera';
    } else if (userAgent.indexOf('msie') != -1) {
        return 'ie';
    } else if (userAgent.indexOf('chrome') != -1) {
        return 'chrome';
    } else if (userAgent.indexOf('safari') != -1) {
        return 'safari';
    } else if (userAgent.indexOf('trident') != -1) {
        return 'ie';
    } else if (userAgent.indexOf('firefox') != -1) {
        return 'firefox';
    } else if (userAgent.indexOf('gecko') != -1) {
        return 'gecko';
    } else {
        return false;
    }
}

/**
 *
 * @param filePath
 */
function isGroupPage(filePath) {

    //受け取ったパスの最後の/の直前が複数の数字になっているかどうか→正規表現でチェック
    var $dir = filePath.split("/");
    var regExp = new RegExp("[0-9]");

    return regExp.test($dir[$dir.length - 2]);
}

/**
 * 画面下部のページ遷移リンク
 */
function footerNavigation() {

    var drw = document.getElementById("footer-navigation");

    /*----------------------------------------*/
    /*  以下条件分岐 / 表示処理部分
     /*----------------------------------------*/
    var URL = window.location.pathname.replace(breadCrumbJsData.ignorePath, '');

    var thisURL = new Array();

    //連想配列のサイズを保持する
    var arraysize = 0;

    var isException = isExceptionPath(URL)

    if (!isException) {
        //デフォルト
        switch (URL.substring(URL.lastIndexOf("/") + 1, URL.length)) {
            case 'index.html':
                //                drw.innerHTML += '<a href="../index.html" class="button" id="footer-button-back">' + '戻る' + '</a>';
                drw.innerHTML += '<a href="./2.html" class="button" id="footer-button-next">' + '次 ：' + breadCrumbJsData.defaultContentName['2.html'] + '</a>';
                break;
            case '2.html':
                drw.innerHTML += '<a href="./index.html" class="button" id="footer-button-back">' + '前 ：' + breadCrumbJsData.defaultContentName['index.html'] + '</a>';
                drw.innerHTML += '<a href="./3.html" class="button" id="footer-button-next">' + '次 ：' + breadCrumbJsData.defaultContentName['3.html'] + '</a>';
                break;
            case '3.html':
                drw.innerHTML += '<a href="./2.html" class="button" id="footer-button-back">' + '前 ：' + breadCrumbJsData.defaultContentName['2.html'] + '</a>';
                drw.innerHTML += '<a href="./4.html" class="button" id="footer-button-next">' + '次 ：' + breadCrumbJsData.defaultContentName['4.html'] + '</a>';
                break;
            case '4.html':
                drw.innerHTML += '<a href="./3.html" class="button" id="footer-button-back">' + '前 ：' + breadCrumbJsData.defaultContentName['3.html'] + '</a>';
                drw.innerHTML += '<a href="./5.html" class="button" id="footer-button-next">' + '次 ：' + breadCrumbJsData.defaultContentName['5.html'] + '</a>';
                break;
            case '5.html':
                drw.innerHTML += '<a href="./4.html" class="button" id="footer-button-back">' + '前 ：' + breadCrumbJsData.defaultContentName['4.html'] + '</a>';
                drw.innerHTML += '<a href="./6.html" class="button" id="footer-button-next">' + '次 ：' + breadCrumbJsData.defaultContentName['6.html'] + '</a>';
                break;
            case '6.html':
                drw.innerHTML += '<a href="./5.html" class="button" id="footer-button-back">' + '前 ：' + breadCrumbJsData.defaultContentName['5.html'] + '</a>';
                drw.innerHTML += '<a href="#" class="button" id="footer-button-next">' + '表示しない'+'</a>';
                break;
        }
    } else {
        //それ以外
        for (key in breadCrumbJsData.contentName) {
            if (key.substring(0, key.lastIndexOf("/")) == URL.substring(1, URL.lastIndexOf("/"))) {
                thisURL[key.substring(key.lastIndexOf("/") + 1, key.length)] = breadCrumbJsData.contentName[key];
                arraysize++;
            }
        }
        switch (URL.substring(URL.lastIndexOf("/") + 1, URL.length)) {
            case 'index.html':
                //                drw.innerHTML += '<a href="../index.html" class="button" id="footer-button-back">' + '戻る' + '</a>';
                drw.innerHTML += '<a href="./2.html" class="button" id="footer-button-next">' + '次 ：' + thisURL['2.html'] + '</a>';
                break;
            case '2.html':
                drw.innerHTML += '<a href="./index.html" class="button" id="footer-button-back">' + '前 ：' + thisURL['index.html'] + '</a>';
                drw.innerHTML += '<a href="./3.html" class="button" id="footer-button-next">' + '次 ：' + thisURL['3.html'] + '</a>';
                break;
            case '3.html':
                drw.innerHTML += '<a href="./2.html" class="button" id="footer-button-back">' + '前 ：' + thisURL['2.html'] + '</a>';
                drw.innerHTML += '<a href="./4.html" class="button" id="footer-button-next">' + '次 ：' + thisURL['4.html'] + '</a>';
                break;
            case '4.html':
                drw.innerHTML += '<a href="./3.html" class="button" id="footer-button-back">' + '前 ：' + thisURL['3.html'] + '</a>';
                if (arraysize > 4) {
                    drw.innerHTML += '<a href="./5.html" class="button" id="footer-button-next">' + '次 ：' + thisURL['5.html'] + '</a>';
                }else{
                    drw.innerHTML += '<a href="#" class="button" id="footer-button-next">' + '表示しない'+'</a>';
                }
                break;
            case '5.html':
                drw.innerHTML += '<a href="./4.html" class="button" id="footer-button-back">' + '前 ：' + thisURL['4.html'] + '</a>';
                if (arraysize > 5) {
                    drw.innerHTML += '<a href="./6.html" class="button" id="footer-button-next">' + '次 ：' + thisURL['6.html'] + '</a>';
                }else{
                    drw.innerHTML += '<a href="#" class="button" id="footer-button-next">' + '表示しない'+'</a>';
                }
                break;
            case '6.html':
                drw.innerHTML += '<a href="./5.html" class="button" id="footer-button-back">' + '前 ：' + thisURL['5.html'] + '</a>';
                if (arraysize > 6) {
                    drw.innerHTML += '<a href="./7.html" class="button" id="footer-button-next">' + '次 ：' + thisURL['7.html'] + '</a>';
	            }else{
	                drw.innerHTML += '<a href="#" class="button" id="footer-button-next">' + '表示しない'+'</a>';
	            }
                break;
            case '7.html':
                drw.innerHTML += '<a href="./6.html" class="button" id="footer-button-back">' + '前 ：' + thisURL['6.html'] + '</a>';
                drw.innerHTML += '<a href="#" class="button" id="footer-button-next">' + '表示しない'+'</a>';
                break;
        }

    }

}